/* Example: National Lottery numbers selector */
/* Version 3: Random number generator seeding added. Integer 
constants 6 and 49 are now #define'd. */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#define BALLS 49  /* the total number of balls */
#define DRAWN 6   /* the number of balls drawn */

void choose_numbers(int selection[DRAWN]);
void print_numbers(int selection[DRAWN]);
int random_ball(int min, int max);
void seed_rand(void);


main()
{
  int selection[DRAWN];  /* array of numbers selected */
  
  choose_numbers(selection);
  print_numbers(selection);
  return;
}


void choose_numbers(int selection[DRAWN])
{
  int i;
  
  seed_rand();  /* to give a different sequence each time */
  
  for (i = 0; i < DRAWN; i++)
    selection[i] = random_ball(1, BALLS);
  return;
}


void print_numbers(int selection[DRAWN])
{
  int i;
  
  for (i = 0; i < DRAWN; i++)
    printf("%i ", selection[i]);
  putchar('\n');
  return;
}


int random_ball(int min, int max)
{
  double x;
  
  x = (double) rand(); /* returns integer from 0 to RAND_MAX */
  
  x /= ((double) RAND_MAX + 1);  /* a double from 0 to just less than 1 */
  /* Leaving out the cast gave overflow problems. Not sure why. */
  
  x = (max - min + 1) * x + min;
                       /* a double from min to just less than max + 1 */
  return (int) x;
}


void seed_rand(void)
{
  time_t t;  /* see <time.h> documentation for details */
  
  time(&t);  /* A new seed every second. Is this often enough? */
  srand(t);
  return;
}
